BorderedMorph subclass: #ScratchSpriteLibraryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-UI-Support'!

!ScratchSpriteLibraryMorph methodsFor: 'dropping/grabbing' stamp: 'jens 6/14/2009 01:54'!
acceptDroppingMorph: aMorph event: evt
	"This method allows re-ordering of sprites in the sprite library area."

	| insertAfter libraryItems spriteLibrary movedThumbnail mostOverlap mostOverlapIndex sf |
	((aMorph isKindOf: LibraryItemMorph) and:
	 [(spriteLibrary _ self ownerThatIsA: ScratchSpriteLibraryMorph) notNil])
		ifFalse: [^ super acceptDroppingMorph: aMorph event: evt].

	"Set the new position of the morph that just moved"
	movedThumbnail _ self submorphs detect: [:m | (m target == aMorph target)] ifNone: [^ self].

	libraryItems _ self submorphs select: [:m | 
		(m bounds intersects: aMorph bounds) and:
		[(m ~~ aMorph)]].

	"Select the thumbnail with the most overlap with movedThumbnail"
	libraryItems _ libraryItems sort: [:m1 :m2 | 
		((m1 bounds intersect: aMorph bounds) area < 
			(m2 bounds intersect: aMorph bounds) area)].

	movedThumbnail position: aMorph position.
	aMorph delete.

	libraryItems isEmpty
		ifTrue: [insertAfter _ nil]  "end of list"
		ifFalse: [
			mostOverlap _ libraryItems last.
			(movedThumbnail center x > mostOverlap center x)
				ifTrue: [
					mostOverlapIndex _ self submorphs indexOf: mostOverlap.
					self submorphCount == mostOverlapIndex
						ifTrue: [insertAfter _ nil]
						ifFalse: [insertAfter _ self submorphs at: (mostOverlapIndex + 1)]]
				ifFalse: [insertAfter _ mostOverlap]].

	spriteLibrary insertItem: movedThumbnail before: insertAfter.

	sf _ self ownerThatIsA: ScratchFrameMorph.
	sf ifNotNil: [ sf workPane updateSpritesList ].
! !

!ScratchSpriteLibraryMorph methodsFor: 'dropping/grabbing' stamp: 'tis 11/10/2006 18:07'!
insertItem: item1 before: item2orNil
	"Shuffle my sprite thumbnails.  I rearrange my submorphs so that the library is shuffled and layed out properly.  I don't bother updating the sprites list which is stored in the stage; I let it update on its own when updateSpritesList is called"

	| nextItem |
	item1 == item2orNil ifFalse: [
		item2orNil
			ifNil: [
				self addMorphBack: item1]
			ifNotNil: [
				self removeAllMorphsIn: (Array with: item1).
				self replaceSubmorph: item2orNil by: item1.
				nextItem _ item2orNil.
				self submorphsBehind: item1 do: [:s |
					self replaceSubmorph: s by: nextItem.
					nextItem _ s].
				self addMorphBack: nextItem]].
	(self ownerThatIsA: ScratchLibraryMorph) fixLayout.
! !

!ScratchSpriteLibraryMorph methodsFor: 'dropping/grabbing' stamp: 'tis 10/1/2006 15:08'!
isPartsBin

	^ true
! !

!ScratchSpriteLibraryMorph methodsFor: 'dropping/grabbing' stamp: 'tis 10/1/2006 15:43'!
rootForGrabOf: aMorph
	"I act like a parts bin; answer a new copy of the morph being extracted."

	| root |
	root _ aMorph.
	(root isKindOf: BlockMorph) ifFalse: [^ nil].
	[root = self] whileFalse: [
		root owner == self ifTrue: [^ root fullCopy].
		root _ root owner].

	^ super rootForGrabOf: aMorph
! !

!ScratchSpriteLibraryMorph methodsFor: 'dropping/grabbing' stamp: 'tis 10/1/2006 15:10'!
wantsDroppedMorph: aMorph event: evt

	^ (aMorph isKindOf: LibraryItemMorph)
! !
