BlockElementMorph subclass: #MethodElementMorph
	instanceVariableNames: 'header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 01:03'!
asCompiledMethodForClass: aClass
	| mn1 cm st |
	st _ self asSmalltalk.
	mn1 _ Compiler new compile: st in: aClass notifying: nil ifFail: [self inform: 'compiling failed'].
	cm _ mn1 generate: #(0 0 0 0).
	^cm ! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:37'!
asSmalltalk
	| ws vn|
	ws _ WriteStream on: String new.
	ws nextPutString: header asSmalltalk; cr; cr.
	(vn _ self localVariableNames) isEmpty ifFalse: [
		ws nextPutString: '| '.
		vn do: [:n|
			ws nextPutString: n, ' ' ].
		ws
			nextPutString: '|';
			nextPut: Character cr].
	ws nextPutString: steps asSmalltalk.
	^ws contents! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:35'!
contextMenu
	|m|
	m _ super contextMenu.
	self isRenameable ifTrue: [
		m addLine.
		m add: 'rename...' action: #editSelector ].
	^m! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/16/2009 00:24'!
editSelector
	header editSelector! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 10:58'!
fit
	| bw bw2 cw handle x y editor|

	header ifNil: [^self ].
	bw _ self borderWidth.
	bw2 _ bw * 2.
	cw _ self labelFont widthOf: $ .
	handle _ cw.

	header position: (self left + bw + handle) @ (self top).

	palette position: (self left + handle) @ (header bottom).
	(palette height = 0)
		ifTrue: [y _ header bottom + (bw * 3)]
		ifFalse: [y _ palette bottom].
	

	steps position: (self left + bw2 + handle) @ y.

	x _ ((steps right + bw2) max: palette right) max: header right.

	self width: x - self left.
	(palette height = 0)
		ifTrue: [ self height: steps height + header height + (bw * 6) ]
		ifFalse: [self height: steps height + palette height + header height + (bw2) ].

	self refreshVarColors.

	(owner respondsTo: #fit)
		ifTrue: [^owner fit].

	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	editor ifNotNil: [editor methodModified ]! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:37'!
fitMethod
	|editor|
	(self findA: StepHolderElementMorph) fitMethod.
	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	editor ifNotNil: [editor methodModified ]! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:48'!
initialize
	super initialize.
	color _ Color paleTan.
	steps color: color slightlyDarker.
	header _ MessageHeaderElementMorph new.
	self addMorph: header.
	self fit.! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 14:22'!
isRenameable
	^true! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:37'!
localVariableNames
	^super variableNames! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:58'!
rootForGrabOf: aMorph
	"Allow myself to be extracted."

	(self ownerThatIsA: ElementsMethodEditorMorph) notNil
		ifTrue: [^nil].
	^super rootForGrabOf: aMorph! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:33'!
selector
	^header selector asSymbol! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:31'!
selector: aSymbol arguments: aCollection
	header selector: aSymbol arguments: aCollection! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 23:03'!
stackBottom
	steps contents isNil
		ifTrue: [^self bottom ]
		ifFalse: [^steps contents stack last bottom ]
	! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:06'!
variableNames
	^super variableNames, header variableNames! !
