CommandScriptBlockMorph subclass: #CSlotMorph
	instanceVariableNames: 'implicitValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 20:02'!
blockWidth
	| maxWidth |
	maxWidth _ 0.
	self firstBlockList do: [:b |
		maxWidth _ maxWidth max: b blockWidth ].
	^ 10 "2" + maxWidth! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/20/2010 22:57'!
computeHighlightColors

	| h s v |
	owner ifNotNil: [
		color = owner color ifFalse: [
			self color: owner color]].
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	highlightColor1 _ Color h: h s: (s - 0.13) v: (v + 0.1).
	highlightColor2 _ Color h: h s: s v: (v + 0.07).
	shadowColor _ color mixed: 0.55 with: Color black.
! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 3/17/2010 12:40'!
drawBottomBarOn: aCanvas 

	| left barTop barBottom |

	barBottom _ self bottom.

	barTop _ barBottom - 3.
	left _ self left.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 1)@(barTop + 1))
		color: highlightColor1.

	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.
! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 7/22/2010 22:29'!
drawOn: aCanvas 

	| c |
	topBarBottom _ self top.
	blockBottom _ self bottom.
	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.

	c
		fillRectangle: self bounds
		color: Color lightGray "(color mixed: 0.6 with: Color darkGray)".

	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self nestedBlock ifNotNil: [ c paintImage: (nestedBlock imageForm withOutlineColor: Color gray width: 4) 
					at: self position + (1@3) ].

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas.

! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 20:11'!
drawTopBarOn: aCanvas 

	| left right y gapStart gapEnd |

	left _ 0.
	right _ self width - 1.
	y _ topBarBottom - self top.

" ---- original: ---------
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.
"
	gapStart _ left + PuzzleInset + 9.
	gapEnd _ gapStart + PuzzleWidth - 8.

	nestedBlock ifNil: [
		gapStart _ left + PuzzleInset - 4.
		gapEnd _ gapStart + PuzzleWidth - 5 ].


	self drawHLineFrom: left to: right y: y color: color on: aCanvas.
	self drawHLineFrom: left to: right y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 1 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.


! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 3/17/2010 12:42'!
drawVerticalBarOn: aCanvas 

	| left barRight |
	left _ self left.
	barRight _ left.

	aCanvas
		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.

	aCanvas
		fillRectangle: ((self bounds topRight + (-1@0)) corner: (self bounds corner ))
		color: color.

	aCanvas
		fillRectangle: ((self bounds topRight + (-1@2)) corner: (self bounds corner - (0@3)))
		color: highlightColor2.
! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/20/2010 22:57'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newW newH |
	blockLayoutNeeded ifFalse: [^ self].
	owner ifNotNil: [
		color = owner color ifFalse: [
			self color: owner color]].

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].

	newW _ 28 max: self blockWidth.

	newH _ self topBarHeight + 12 "+ self bracketThickness!!".

	nestedBlock
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ "newH +" nestedBlock fullBounds height + 10.
			nestedBlock position: self position + (5 "1"@(self topBarHeight + 4)).
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].
	self extent: newW@newH

! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/6/2010 22:12'!
topBarHeight
	"Answer the height of the top bar."

	| nonBlockSubmorphs |
	nonBlockSubmorphs _ self submorphs select: [:m |
		(m isKindOf: BlockMorph) not or: [argMorphs includes: m]].
	^ nonBlockSubmorphs inject: 3 into: [:h :m | h max: (m height + 3)].

! !


!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/17/2010 01:01'!
acceptsDroppedReporters

	^ true
! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/25/2011 00:17'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	aBlockMorph isReporter ifFalse: [^ false].
	^ (aBlockMorph isKindOf: VariableBlockMorph) or: [

		^ #(
			autoLambda
			loopLambda
			getLine:ofList:
			getVar:
			procedure
			procedureWithArgs
			doReport
			doCallBlockWithArgs
			doCallBlockWithArgList
			doCustomBlock
			getAttribute:of:
			attribute:of:
		) includes: aBlockMorph selector]! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/17/2010 17:28'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |

	result _ #().

	nestedBlock
		ifNil: [ result _ result copyWith: ((self topLeft + (1@(self topBarHeight + 3))) -> self)]
		ifNotNil: [nestedBlock blockAttachPoints: aSet].

	aSet addAll: result.

! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/16/2010 21:41'!
handlesMouseDown: evt

	^false! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/17/2010 02:20'!
initialize
	super initialize.
	isSpecialForm _ true.
	selector _ #autoLambda! !


!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:19'!
defaultValue: default
	"do nothing"! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:13'!
evaluate

	implicitValue notNil
		ifTrue: [^implicitValue].
	^ super evaluate! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:15'!
evaluateWithArgs: rawArgs

	implicitValue notNil
		ifTrue: [^implicitValue].
	^super evaluateWithArgs: rawArgs! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:20'!
fixArgLayout
	"Fix my layout. This default implementation does nothing."! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:11'!
implicitValue
	^ implicitValue! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:11'!
implicitValue: anObject
	implicitValue _ anObject! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:09'!
isEmptySlot
	^ nestedBlock isNil! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:08'!
isKindOf: aClass
	aClass = ArgMorph 
		ifTrue: [^ true].
	^ super isKindOf: aClass
! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 6/22/2010 20:29'!
isLambdaForm
	^ false! !


!CSlotMorph methodsFor: 'Enchanting' stamp: 'JM 10/21/2011 10:13'!
exportArgWith: arg havingSpec: spec

	"does nothing - a CSlot is an empty slot on a run / launch etc block - handled here to avoid exception in Enchanting"! !


!CSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 11:34'!
paddedHeightWhenPlacedAt: place
"How heigh is this morph when placed as the nth element,
along a line of elements in a command block?"

	| h |

	h _ self height.

	(self isEmptySlot not and: [place = 1]) ifTrue: [ ^ h + 10 ].
	^ h + 5.
! !
